# -*- coding: utf-8 -*-
import os
import time
import oss2

from resource import pcdtovideo_monitor_overlook

import logging

path1 = '/mnt/disk001/dcl_data_process/src/python2/pjibot_delivery/'
logging.basicConfig(filename=path1 + 'log/pcd.log', level=logging.INFO,
                    format='%(asctime)s - %(levelname)s - %(message)s')

key1 = 'pjibot_delivery/'
path1 = '/root/'
sleep_time = 30  # 每多少秒扫描一次


def parse_to_pcd_mp4(merged_bag_file_path, parse_prefix2, local_parse_dir, local_delete_list):
    global bucket
    try:
        local_pcd_mp4_dir = pcdtovideo_monitor_overlook.parse(merged_bag_file_path, local_parse_dir + '/pcd/')
        pcd_mp4_file_name = 'pcd_overlook'
        local_delete_list.append(str(local_pcd_mp4_dir) + '/pcd_overlook.mp4')
        oss_csv_object_key3 = parse_prefix2 + pcd_mp4_file_name + '.mp4'
        bucket.put_object_from_file(oss_csv_object_key3, str(local_pcd_mp4_dir) + '/' + pcd_mp4_file_name + '.mp4')
        logging.info("上传点云视频到: %s", oss_csv_object_key3)
    except Exception as e:
        logging.exception("生成点云视频报错: %s" % str(e))


'''
cname：http://open-bucket.oss.icvdc.com
内网endpoint: oss-cn-beijing-gqzl-d01-a.ops.gqzl-cloud.com
oss桶名： open-bucket
keyid：n8glvFGS25MrLY7j
secret：xZ2Fozoarpfw0z28FUhtg8cu0yDc5d
'''
# ------- 获取合并之后的bag包，解析出csv -------
if __name__ == '__main__':
    # 1 创建阿里云对象
    auth = oss2.Auth('n8glvFGS25MrLY7j', 'xZ2Fozoarpfw0z28FUhtg8cu0yDc5d')
    endpoint = 'oss-cn-beijing-gqzl-d01-a.ops.gqzl-cloud.com'
    bucket = oss2.Bucket(auth, endpoint, 'pji-bucket1')
    while True:
        logging.info("开始新一轮扫描")
        try:
            local_delete_list = []
            oss_delete_list = []
            prefix_list = []
            # 2 获取已经上传完成的所有目录并分组
            for obj1 in oss2.ObjectIterator(bucket, prefix=key1):
                try:
                    # 获取合并后的包
                    merged_bag_object_key = str(obj1.key)
                    if 'data_merge' in str(obj1.key) and str(obj1.key).endswith('.bag'):
                        merged_bag_object_key_split = merged_bag_object_key.split('/')
                        merged_prefix = '/'.join(merged_bag_object_key_split[:-1])
                        parse_prefix = merged_prefix.replace('data_merge', 'data_parse')
                        parse_prefix_full = merged_bag_object_key.replace('data_merge', 'data_parse')[:-4] + '/'
                        pcd_done = False
                        callback_done = False
                        for obj2 in oss2.ObjectIterator(bucket, prefix=parse_prefix_full):
                            if '/callback.json' in str(obj2.key):
                                callback_done = True
                            if '/pcd_overlook.mp4' in str(obj2.key):
                                pcd_done = True
                        if not callback_done:
                            continue
                        if pcd_done:
                            continue
                        logging.info("%s 需要生成点云视频 pcd_overlook.mp4" % str(parse_prefix_full))
                        local_merged_bag_path = path1 + 'pcd/' + merged_bag_object_key
                        local_merged_dir = '/'.join(local_merged_bag_path.split('/')[:-1])
                        local_parse_dir = local_merged_dir.replace('data_merge', 'data_parse')
                        if not os.path.exists(local_merged_dir):
                            os.makedirs(local_merged_dir)
                        if not os.path.exists(local_parse_dir):
                            os.makedirs(local_parse_dir)
                        merged_bag_full_name = merged_bag_object_key_split[-1]
                        merged_bag_name = merged_bag_full_name.split('.')[0]
                        bucket.get_object_to_file(merged_bag_object_key, local_merged_bag_path)
                        local_delete_list.append(local_merged_bag_path)
                        # 2 生成 pos_orig.csv 和 pos_hmi.csv
                        parse_to_pcd_mp4(local_merged_bag_path, parse_prefix_full, local_parse_dir, local_delete_list)
                except Exception as e:
                    logging.exception("报错: %s" % str(e))
            # 删除本地临时文件
            if len(local_delete_list) > 0:
                for local_delete in local_delete_list:
                    try:
                        os.remove(local_delete)
                    except Exception as e:
                        logging.exception("删除本地临时文件报错: %s" % str(e))
            time.sleep(sleep_time)
        except Exception as e:
            logging.exception("全局异常处理: %s" % str(e))
